<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;
		
	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkAPI.php");
	
	/*
	 * Information sur l'API exposée
	 *
	 */
	class PolarisLinkAPI_VersionModuleFrontController extends PolarisLinkAPI
	{
		public function checkAccess()
		{
			return true;
		}
		
		function convertToBytes($from)
		{
			$number = trim(substr($from,0,-2));
			switch(trim(strtoupper(substr($from,-2))))
			{
				case "KB":
					return $number*1024;
				case "MB":
					return $number*pow(1024,2);
				case "GB":
					return $number*pow(1024,3);
				case "TB":
					return $number*pow(1024,4);
				case "PB":
					return $number*pow(1024,5);
				default:
					$number = trim(substr($from,0,-1));
					switch(trim(strtoupper(substr($from,-1))))
					{
						case "K":
							return $number*1024;
						case "M":
							return $number*pow(1024,2);
						case "G":
							return $number*pow(1024,3);
						case "T":
							return $number*pow(1024,4);
						case "P":
							return $number*pow(1024,5);
						default:
							return $from;
					}
			}
		}
	
		protected function runAPI()
		{
			if ($_REQUEST["php_info_needed"])
			{
				phpinfo();
			}
			else
			{
				$infos = array(
					"api_installed" => true,
					"api_enabled" => true,
					"version" => $this->module->version,
					"full_version" => PolarisLink::getFullVersion(),
					"support_zip" => function_exists("gzopen"),
					"php" => phpversion(),				
					"fpm" => function_exists("fastcgi_finish_request"),
					"libs" => get_loaded_extensions(),
					"max_upload" => 
									min(1000000000,
									max(2000000, min( 									
										$this->convertToBytes(ini_get("post_max_size")), 
										$this->convertToBytes(ini_get("memory_limit")), 
										$this->convertToBytes(ini_get("upload_max_filesize")))) - 1000000)
					);
				$this->answerJSON($infos);
			}
			
			return true;
		}
	}
 